diff -2rcN /usr/goinfre/gcc-2.7.0/Product-Info gcc-2.7.0-amiga/Product-Info
*** /usr/goinfre/gcc-2.7.0/Product-Info
--- gcc-2.7.0-amiga/Product-Info	Fri Jun 23 11:52:13 1995
***************
*** 0 ****
--- 1,22 ----
+ .name
+ gcc
+ .fullname
+ GNU C/C++/Objective-C compiler
+ .type
+ Compiler
+ .short
+ GNU C/C++/Obj-C compilers.
+ .description
+ The GNU C, C++, and Objective C compilers.  Includes all support for
+ compiling C, C++ and Objective C, including a run-time library for
+ Objective C.
+ .version
+ 2.6.4
+ .author
+ Free Software Foundation
+ .requirements
+ Amiga binaries require ixemul.library.
+ .distribution
+ GNU Public License
+ .described-by
+ Fred Fish (fnf@amigalib.com)
diff -2rcN /usr/goinfre/gcc-2.7.0/amigasup.c gcc-2.7.0-amiga/amigasup.c
*** /usr/goinfre/gcc-2.7.0/amigasup.c
--- gcc-2.7.0-amiga/amigasup.c	Fri Jun 23 11:52:14 1995
***************
*** 0 ****
--- 1,171 ----
+ /* Supplementary host support for AmigaDOS.  Used only when host is AmigaDOS.
+    Copyright (C) 1994 Free Software Foundation, Inc.
+ 
+ This file is part of GNU CC.
+ 
+ GNU CC is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ GNU CC is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with GNU CC; see the file COPYING.  If not, write to
+ the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ 
+ This code segment will interface between the startup code and the user's
+ main(), adjusting the stack if necessary. Two entry points are provided,
+ main(), and stkexit(). Programs should be compiled using
+ 	gcc -Dmain=stkmain -Dexit=stkexit
+ and linked with this module.  Calling _exit is not provided for, but should
+ be trivial to implement.
+ 
+ The minimum acceptable stack size is obtained from the environment variable
+ GCC_STACK (change the #define ENVNAME to customize). If this variable is
+ not defined, the default is 50000 bytes (change the #define SIZE to
+ customize). If the current stack size is less than the minimum acceptable,
+ then a new stack is allocated, and appropriate actions are taken to ensure
+ that the original stack is restored before exit.
+ 
+ To link with my stderrfix hack, you will need to compile it using
+    	gcc -Dmain=stkmain -c stderrfix.c
+ and compile everything else (apart from this file) using
+    	gcc -Dmain=mymain -Dexit=stkexit
+ (I have not tested this, but there is no reason why it shouldn't work.)
+ 
+ AUTHOR:     Kriton Kyrimis (kyrimis@theseas.ntua.gr)
+ KNOWN BUGS: Calling stkexit(0x8000000) will cause the program to exit
+             with the wrong exit code (0).
+ DISCLAIMER: Use this code at your own risk.
+ */
+ 
+ /* Putting this in version.c seems to screw up configure, which attempts to
+    extract the version number with a sed command that doesn't take this
+    string into account.  Also, don't include the date of compilation
+    in this string because the annoyance of not being able to do multistage
+    build comparisons across days is more than the convenience gained
+    (if any) by having the build date incoporated in the executables. -fnf */
+ char VERSION[]="$VER:gcc 2.6.4";
+ 
+ #undef main
+ #undef exit
+ 
+ #include <stdlib.h>
+ #include <setjmp.h>
+ #include <dos/dosextens.h>
+ #include <proto/exec.h>
+ #include <proto/dos.h>
+ 
+ #define SIZE 50000
+ #define ENVNAME "GCCSTACK"
+ 
+ #define MAGIC 0x80000000
+ 
+ void stkexit(int);
+ 
+ static jmp_buf jmp;
+ static int swapped = 0;
+ 
+ main(int argc, char **argv)
+ {
+   /* Declare all variables as static, so that they are available no matter
+      which stack is active */
+   static struct Process *p;
+   static struct CommandLineInterface *c;
+   static int stacksize, prefsize, status;
+   static struct StackSwapStruct stack;
+   static char *envsize, *newstack;
+   /* The next two variables point to information in the old stack. Declare
+      them volatile, to avoid unexpected surprises introduced by the optimizer.
+      (This is apparently unnecessary under 2.6.1, but you never know.) */
+   static volatile int myargc;
+   static volatile char **myargv;
+ 
+   /* Determine original stack size */
+   p = (struct Process *)FindTask(NULL);
+   c = BADDR(p->pr_CLI);
+   if (c) {
+     stacksize = c->cli_DefaultStack * sizeof(LONG);
+   }else{
+     stacksize = p->pr_StackSize;
+   }
+ 
+   /* Determine preferred stack size */
+   envsize = getenv(ENVNAME);
+   if (envsize) {
+     prefsize = atoi(envsize);
+   }else{
+     prefsize = SIZE;
+   }
+ 
+   myargc = argc;
+   myargv = argv;
+ 
+   if (prefsize > stacksize) {
+     /* Round size to next long word */
+     prefsize = ((prefsize + (sizeof(LONG) - 1)) / sizeof(LONG)) * sizeof(LONG);
+ 
+     /* Allocate new stack */
+     newstack = malloc(prefsize);
+     if (!newstack) {
+       Printf("Can't allocate new stack!\n");
+       exit(RETURN_FAIL);
+     }
+ 
+     /* Build new stack structure */
+     stack.stk_Lower = newstack;
+     stack.stk_Upper = (ULONG)newstack + prefsize;
+     /* Determine the address the stackpointer has to go:
+      * Point to the last longword of the stackframe and subtract
+      * the arguments of StackSwap() since the compiler might
+      * try to adjust the stackpointer after calling it :-(.
+      */
+     stack.stk_Pointer = (APTR)(stack.stk_Upper-2*sizeof(long));
+ 
+     /* Switch to new stack */
+     StackSwap(&stack);
+     swapped = 1;
+     if (c) {
+       c->cli_DefaultStack = prefsize / sizeof(LONG);
+     }
+ 
+     /* Save the current position, so that on exit we may return to the exact
+        stack depth where we switched stacks, and switch them back again.
+        Programs should invoke stkexit() rather than exit(), or return from
+        stkmain(). Status contains the exit status given to stkexit().*/
+     if ((status = setjmp(jmp)) != 0) {
+       /* Switch back to old stack before exiting */
+       StackSwap(&stack);
+       if (c) {
+ 	c->cli_DefaultStack = stacksize / sizeof(LONG);
+       }
+       free(newstack);
+       if (status == MAGIC) {	/* If real exit status is 0, stkexit converts */
+         status = 0;		/* it to MAGIC, to avoid confusing setjmp */
+       }
+       exit(status);
+     }
+     status = stkmain(myargc, myargv);
+     stkexit(status);
+   } else {
+     return stkmain(myargc, myargv);
+   }
+ }
+ 
+ void
+ stkexit(int status)
+ {
+   if (!swapped) {
+     exit (status);
+   } else {
+     if (status == 0) {	/* The world will end iff we pass 0 as the value */
+       status = MAGIC;	/* for longjmp */
+     }
+     longjmp(jmp, status);
+   }
+ }
+ 
diff -2rcN /usr/goinfre/gcc-2.7.0/calls.c gcc-2.7.0-amiga/calls.c
*** /usr/goinfre/gcc-2.7.0/calls.c	Thu Jun 15 12:15:32 1995
--- gcc-2.7.0-amiga/calls.c	Fri Jun 23 11:52:15 1995
***************
*** 2264,2267 ****
--- 2264,2275 ----
    argvec = (struct arg *) alloca (nargs * sizeof (struct arg));
  
+ #if defined (__amigados__)
+ /* how would you do this RIGHT ?? fake a DECL node? dunno... */
+ #ifdef ENCODE_SECTION_INFO
+   /* mark it as a function (to be in the text section that is) */
+   SYMBOL_REF_FLAG (fun) = 1;
+ #endif
+ #endif
+ 
    INIT_CUMULATIVE_ARGS (args_so_far, NULL_TREE, fun);
  
***************
*** 2572,2575 ****
--- 2580,2591 ----
    argvec = (struct arg *) alloca ((nargs + 1) * sizeof (struct arg));
  
+ #if defined (__amigados__)
+ /* how would you do this RIGHT ?? fake a DECL node? dunno... */
+ #ifdef ENCODE_SECTION_INFO
+   /* mark it as a function (to be in the text section that is) */
+   SYMBOL_REF_FLAG (fun) = 1;
+ #endif
+ #endif
+ 
    INIT_CUMULATIVE_ARGS (args_so_far, NULL_TREE, fun);
  
diff -2rcN /usr/goinfre/gcc-2.7.0/cccp.c gcc-2.7.0-amiga/cccp.c
*** /usr/goinfre/gcc-2.7.0/cccp.c	Thu Jun 15 12:16:31 1995
--- gcc-2.7.0-amiga/cccp.c	Sun Jun 25 15:41:07 1995
***************
*** 41,44 ****
--- 41,62 ----
  #endif /* not EMACS */
  
+ #ifdef INHIBIT_ALLOCA_USE
+ /* Since cpp uses alloca to store all its read files, this is quite deadly
+    on a system with non-automatic stackgrowth like amigados, so we better
+    turn it off now.  Normally alloca is #defined to __builtin_alloca, so
+    undefining it causes an external alloca to be used.
+ 
+    Note that it's not wise to generally inhibit __builtin_alloca, since
+    using the generic emulator results in a serious (!) speed penalty, and
+    it's bad enough that we have to live with it in cccp, don't make cc1
+    unbearably slow as well... */
+ 
+ #undef alloca
+ #endif
+ 
+ #ifdef __amigados__
+ static int amigados_abs_filename ();
+ #endif
+ 
  #ifndef STANDARD_INCLUDE_DIR
  #define STANDARD_INCLUDE_DIR "/usr/include"
***************
*** 361,364 ****
--- 379,390 ----
  static int max_include_len;
  
+ #ifdef __amigados__
+ /* Phil.B: 03-Oct-94 Flag indicating process priority */
+ static int amiga_priority = -1;
+ static int amiga_old_priority;
+ #include <proto/exec.h>
+ struct Task *amiga_task;
+ #endif /* __amigados__ */
+ 
  /* Nonzero means turn NOTREACHED into #pragma NOTREACHED etc */
  
***************
*** 1311,1314 ****
--- 1337,1349 ----
  #endif /* RLIMIT_STACK defined */
  
+ #ifdef __amigados__
+   {
+     char *envstr;
+ 
+     if (envstr = getenv("GCCPRIORITY"))
+       if (((i = atoi(envstr)) > -20) && (i < 20)) amiga_priority = i;
+   }
+ #endif /* __amigados__ */
+ 
  #ifdef SIGPIPE
    signal (SIGPIPE, pipe_closed);
***************
*** 1320,1323 ****
--- 1355,1361 ----
  	 && cp[-1] != DIR_SEPARATOR
  #endif
+ #ifdef VOL_SEPARATOR
+ 	 && cp[-1] != VOL_SEPARATOR
+ #endif
  	 )
      --cp;
***************
*** 1519,1522 ****
--- 1557,1570 ----
  
        case 'p':
+ #ifdef __amigados__
+ 	if (!strcmp (argv[i], "-priority")) {
+ 	  if (i + 1 == argc)
+ 	    fatal ("Priority missing after -P option");
+           if ((amiga_priority = atoi(argv[++i])) < -25)
+ 	    amiga_priority = -25;
+           else if (amiga_priority > 25)
+ 	    amiga_priority = 25;
+         } else
+ #endif /* __amigados__ */
  	if (!strcmp (argv[i], "-pedantic"))
  	  pedantic = 1;
***************
*** 1808,1811 ****
--- 1856,1866 ----
    }
  
+ #ifdef __amigados__
+   Forbid();
+   amiga_task = FindTask(NULL);
+   Permit();
+   amiga_old_priority = SetTaskPri(amiga_task, amiga_priority);
+ #endif /* __amigados__ */
+ 
    /* Add dirs from CPATH after dirs from -I.  */
    /* There seems to be confusion about what CPATH should do,
***************
*** 2166,2169 ****
--- 2221,2227 ----
  
        /* Discard all directory prefixes from filename.  */
+ #ifdef FILE_NAME_NONDIRECTORY
+       q = FILE_NAME_NONDIRECTORY (in_fname);
+ #else
        if ((q = rindex (in_fname, '/')) != NULL
  #ifdef DIR_SEPARATOR
***************
*** 2174,2178 ****
        else
  	q = in_fname;
! 
        /* Copy remainder to mungable area.  */
        p = (char *) alloca (strlen(q) + 8);
--- 2232,2236 ----
        else
  	q = in_fname;
! #endif
        /* Copy remainder to mungable area.  */
        p = (char *) alloca (strlen(q) + 8);
***************
*** 2329,2332 ****
--- 2387,2395 ----
      fatal ("I/O error on output");
  
+ /* PhB 25-Jun-95: restore old process priority before exiting */
+ #ifdef __amigados__
+   SetTaskPri(amiga_task, amiga_old_priority);
+ #endif /* __amigados__ */
+ 
    if (errors)
      exit (FATAL_EXIT_CODE);
***************
*** 4007,4011 ****
--- 4070,4079 ----
        if (!no_output && already_output == 0
  	  && (kt->pass_thru
+ /* Phil.B 27-Mar-93 not quite sure to keep this old fix */	  
+ #if defined (__amigados__) && 0
+ 	      || ((kt->type == T_DEFINE || kt->type == T_UNDEF)
+ #else
  	      || (kt->type == T_DEFINE
+ #endif /* __amigados__ */
  		  && (dump_macros == dump_names
  		      || dump_macros == dump_definitions)))) {
***************
*** 4358,4361 ****
--- 4426,4437 ----
  	    }
  #endif
+ #ifdef VOL_SEPARATOR
+ 	    if (ep == NULL) ep = rindex (nam, VOL_SEPARATOR);
+ 	    else {
+ 	      char *tmp = rindex (nam, VOL_SEPARATOR);
+ 	      if (tmp != NULL && tmp > ep) ep = tmp;
+ 	    }
+ 	    if (ep != NULL && *ep == VOL_SEPARATOR) ep++;
+ #endif
  #else				/* VMS */
  	    ep = rindex (nam, ']');
***************
*** 4484,4487 ****
--- 4560,4566 ----
    /* If specified file name is absolute, just open it.  */
  
+ #ifdef __amigados__
+   if (amigados_abs_filename (fbeg, flen)) {
+ #else
    if (*fbeg == '/'
  #ifdef DIR_SEPARATOR
***************
*** 4489,4492 ****
--- 4568,4572 ----
  #endif
        ) {
+ #endif
      strncpy (fname, (char *) fbeg, flen);
      fname[flen] = 0;
***************
*** 4511,4514 ****
--- 4591,4597 ----
  	  continue;
  	strcpy (fname, searchptr->fname);
+ #ifdef __amigados__
+ 	if (fname[strlen (fname) - 1] != ':')
+ #endif
  	strcat (fname, "/");
  	fname[strlen (fname) + flen] = 0;
***************
*** 9925,9928 ****
--- 10008,10016 ----
    va_list args;
  
+ /* PhB 25-Jun-95: restore old process priority before exiting */
+ #ifdef __amigados__
+   SetTaskPri(amiga_task, amiga_old_priority);
+ #endif /* __amigados__ */
+ 
    fprintf (stderr, "%s: ", progname);
    VA_START (args, msg);
***************
*** 10421,10422 ****
--- 10509,10534 ----
  }
  #endif /* VMS */
+ 
+ 
+ #ifdef __amigados__
+ 
+ /* This function returns whether the LEN characters long filename FNAME 
+    is an absolute path specification. */
+ 
+ static int
+ amigados_abs_filename (fname, len)
+      char *fname;
+      int len;
+ {
+   /* we're using ixemul.library, which treats `/foo' as `foo:', so 
+      fname[0] is to be considered absolute as well */
+   if (fname[0] == '/')
+     return 1;
+ 
+   /* else do an index() on fname, but one which is limited to len characters */
+   while (*fname && *fname != ':' && len) 
+     fname++, len--;
+ 
+   return *fname == ':';
+ }
+ #endif /* __amigados__ */
diff -2rcN /usr/goinfre/gcc-2.7.0/config/m68k/amigados.c gcc-2.7.0-amiga/config/m68k/amigados.c
*** /usr/goinfre/gcc-2.7.0/config/m68k/amigados.c
--- gcc-2.7.0-amiga/config/m68k/amigados.c	Fri Jun 23 11:52:18 1995
***************
*** 0 ****
--- 1,205 ----
+ /* Definitions of target machine for GNU compiler.  amiga 68000/68020 version.
+    Copyright (C) 1992 Free Software Foundation, Inc.
+    Contributed by Markus M. Wild (wild@amiga.physik.unizh.ch).
+ 
+ This file is part of GNU CC.
+ 
+ GNU CC is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ GNU CC is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with GNU CC; see the file COPYING.  If not, write to
+ the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #include "m68k/m68k.c"
+ 
+ /* Does operand (which is a symbolic_operand) live in text space? If
+    so SYMBOL_REF_FLAG, which is set by ENCODE_SECTION_INFO, will be true.
+ 
+    This function is used in base relative code generation. */
+ 
+ int
+ read_only_operand (operand)
+      rtx operand;
+ {
+   if (GET_CODE (operand) == CONST)
+     operand = XEXP (XEXP (operand, 0), 0);
+   if (GET_CODE (operand) == SYMBOL_REF)
+     return SYMBOL_REF_FLAG (operand) || CONSTANT_POOL_ADDRESS_P (operand);
+   return 1;
+ }
+ 
+ 
+ /* the rest of the file is to implement AmigaDOS specific keywords some day.
+    The approach used so far used __attribute__ for this, but this required
+    changes to c-parse.y as well as if we'd use the common keywords used
+    on commercial AmigaDOS C-compilers as well. So in the future I'll probably
+    switch to __saveds and __interrupt keywords as well.
+ 
+    The rest of this file is currently ignored, because it's no longer
+    working with the current gcc version. */
+ 
+ #if not_yet_working
+ 
+ #include "tree.h"
+ 
+ struct attribute {
+   tree ident;
+   int  saveds : 1,
+        interrupt : 1;
+ };
+ 
+ 
+ static struct attribute *a_tab = 0;
+ static int a_index, a_size;
+ 
+ void
+ add_attr_entry (attr)
+     struct attribute *attr;
+ {
+   if (! a_tab)
+     {
+       a_size = 10;
+       a_index = 0;
+       a_tab  = (struct attribute *) xmalloc (a_size * sizeof (struct attribute));
+     }
+ 
+   if (a_index == a_size)
+     {
+       a_size <<= 1;
+       a_tab = (struct attribute *) xrealloc (a_tab, a_size * sizeof (struct attribute));
+     }
+ 
+   a_tab[a_index++] = *attr;
+ }
+ 
+ 
+ void
+ attr_do_saveds (function_ident)
+       tree function_ident;
+ {
+   struct attribute attr, *a;
+   int i;
+ 
+   for (i = 0, a = a_tab; i < a_index; i++, a++)
+     if (a->ident == function_ident)
+       {
+ 	a->saveds = 1;
+ 	return;
+       }
+ 
+   /* create a new entry for this function */
+   attr.ident     = function_ident;
+   attr.saveds    = 1;
+   attr.interrupt = 0;
+   add_attr_entry (&attr);
+ }
+ 
+ void
+ attr_do_interrupt (function_ident)
+     tree function_ident;
+ {
+   struct attribute attr, *a;
+   int i;
+ 
+   for (i = 0, a = a_tab; i < a_index; i++, a++)
+     if (a->ident == function_ident)
+       {
+ 	/* __interrupt implies __saveds */
+ 	a->saveds    = 1;
+ 	a->interrupt = 1;
+ 	return;
+       }
+ 
+   /* create a new entry for this function */
+   attr.ident	 = function_ident;
+   attr.saveds	 = 1;
+   attr.interrupt = 1;
+   add_attr_entry (&attr);
+ }
+ 
+ int
+ attr_does_saveds (function_name)
+     char *function_name;
+ {
+   tree ident = get_identifier (function_name);
+   struct attribute *attr;
+   int i;
+   
+   for (i = 0, attr = a_tab; i < a_index; i++, attr++)
+     if (attr->ident == ident)
+       return attr->saveds;
+ 
+   return 0;
+ }
+ 
+ int
+ attr_does_interrupt (function_name)
+     char *function_name;
+ {
+   tree ident = get_identifier (function_name);
+   struct attribute *attr;
+   int i;
+   
+   for (i = 0, attr = a_tab; i < a_index; i++, attr++)
+     if (attr->ident == ident)
+       return attr->interrupt;
+ 
+   return 0;
+ }
+ 
+ #endif
+ 
+ /*
+ Stack checking and auto-extend
+ 
+ This is my first attempt to implement stack extension with gcc.
+ If you think some things should be changed please write
+ to me immediately (fleischr@izfm.uni-stuttgart.de, or even better
+ to amiga-gcc-port@lists.funet.fi for discussion).
+ 
+ If you don't want to recompile gcc (to check it out) you can still
+ test the example supported (bigtest.c) or read the documentation.
+ Simply do a 'make' to build it.
+ 
+ Matthias
+ */
+ 
+ rtx gen_stack_management_call (stack_pointer, arg, func)
+      rtx stack_pointer; /* rtx to put the result into       */
+      rtx arg;           /* The argument to put into d0      */
+      char *func;        /* The name of the function to call */
+ {
+   rtx fcall, assem;
+   emit_move_insn (gen_rtx (REG, SImode, 0), arg); /* Move arg to d0 */
+   assem = gen_rtx (ASM_OPERANDS, VOIDmode, func, "=r", 0,
+                    rtvec_alloc(1), rtvec_alloc(1), "internal", 0);
+   XVECEXP (assem, 3, 0) = gen_rtx (REG, SImode, 0);
+   XVECEXP (assem, 4, 0) = gen_rtx (ASM_INPUT, SImode, "r");
+   fcall = gen_rtx (PARALLEL, VOIDmode, rtvec_alloc(1+4));
+   XVECEXP (fcall, 0, 0)
+     = gen_rtx (SET, VOIDmode, stack_pointer, assem);
+   XVECEXP (fcall, 0, 1)
+     = gen_rtx (CLOBBER, VOIDmode, gen_rtx (REG, QImode, 9));
+   XVECEXP (fcall, 0, 2)
+     = gen_rtx (CLOBBER, VOIDmode, gen_rtx (REG, QImode, 8));
+   XVECEXP (fcall, 0, 3)
+     = gen_rtx (CLOBBER, VOIDmode, gen_rtx (REG, QImode, 1));
+   XVECEXP (fcall, 0, 4)
+     = gen_rtx (CLOBBER, VOIDmode, gen_rtx (REG, QImode, 0));  
+   return fcall; /* call function sp=func(d0) */
+ }
+ 
+ rtx gen_stack_cleanup_call (stack_pointer,sa)
+      rtx stack_pointer;
+      rtx sa;
+ {
+   return gen_stack_management_call (stack_pointer, sa, "jbsr ___move_d0_sp");
+ }
